=== json.lua/test/nativejson-benchmark/thirdparty/vincenthz-libjson/debian/changelog ===
libjson (0.7-1) unstable; urgency=low

  * Initial release.

 -- William Dauchy <wdauchy@gmail.com>  Tue, 16 Mar 2010 15:45:59 +0100
